{******************************************************************}
{                                                                  }
{ Sample program to test the LHSix compression unit                }
{ May 2002, Prof A Olowofoyeku (The African Chief)                 }
{ Supports:                                                        }
{ TP, BP, TPW, BPW, Delphi, Virtual Pascal, GNU Pascal, FreePascal }
{                                                                  }
{                                                                  }
{******************************************************************}
PROGRAM lh6;

USES lhsix;

{$ifdef Win32}
 {$ifndef VirtualPascal}
 {$ifndef __GPC__}
    {$apptype console}
 {$endif __GPC__}
 {$endif VirtualPascal}
{$endif Win32}

FUNCTION EncodeCallBack ( CONST Count : LH6Long; Decompressing : Boolean ) : LH6Long;
BEGIN
   EncodeCallBack := 0;
   Write ( '+' );
END;

FUNCTION DecodeCallBack ( CONST Count : LH6Long; Decompressing : Boolean ) : LH6Long;
BEGIN
   DecodeCallBack := 0;
   Write ( '#' );
END;

VAR
ToEnc, ToDec : TLH6CallBack;

BEGIN
  ToEnc := EncodeCallBack;
  ToDec := DecodeCallBack;

  Writeln ( 'lh6, Huffmann file compressor v1.11 ' );
  IF ( ParamCount < 2 ) OR ( ParamCount > 3 )
  THEN BEGIN
    Writeln ( 'Usage: ', ParamStr ( 0 ), ' <inputfile> <outputfile> [-u]' );
    Writeln ( '       -u = decompress <inputfile> into <outputfile>' );
    HALT ( 1 );
  END;

  IF ( ParamStr ( 1 ) = ParamStr ( 2 ) )
  THEN BEGIN
      Writeln ( 'File names must be different' );
      HALT ( 2 );
  END;

  IF ( ParamCount <> 3 )
  THEN Writeln ( EncodeFile ( ParamStr ( 1 ), ParamStr ( 2 ), ToEnc ),
       ' bytes written.' )
  ELSE Writeln ( DecodeFile ( ParamStr ( 1 ), ParamStr ( 2 ), ToDec ),
       ' bytes extracted.' );
END.

